"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.wrapAuthenticating = exports.fetchWithSilentAuthenticateAndRetryOn401 = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _recompose = require("recompose");

var _reactOidcRedux = require("@axa-fr/react-oidc-redux");

var fetchWithSilentAuthenticateAndRetryOn401 = function fetchWithSilentAuthenticateAndRetryOn401(trySilentAuthenticateInjected) {
  return function (fetch) {
    return (
      /*#__PURE__*/
      function () {
        var _ref = (0, _asyncToGenerator2["default"])(
        /*#__PURE__*/
        _regenerator["default"].mark(function _callee(url) {
          var options,
              isRetry,
              response,
              _args = arguments;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {
                    method: 'GET'
                  };
                  isRetry = _args.length > 2 && _args[2] !== undefined ? _args[2] : true;
                  _context.next = 4;
                  return fetch(url, options);

                case 4:
                  response = _context.sent;

                  if (!isRetry) {
                    _context.next = 10;
                    break;
                  }

                  if (!(response.status === 401)) {
                    _context.next = 10;
                    break;
                  }

                  _context.next = 9;
                  return trySilentAuthenticateInjected();

                case 9:
                  return _context.abrupt("return", fetchWithSilentAuthenticateAndRetryOn401(trySilentAuthenticateInjected)(fetch)(url, options, false));

                case 10:
                  return _context.abrupt("return", response);

                case 11:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }()
    );
  };
};

exports.fetchWithSilentAuthenticateAndRetryOn401 = fetchWithSilentAuthenticateAndRetryOn401;

var wrapAuthenticating = function wrapAuthenticating(fetchWithSilentAuthenticateAndRetryOn401Injected) {
  return function () {
    var fetch = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
    return function (props) {
      var previousFetch = fetch || props.fetch;
      var newFetch = fetchWithSilentAuthenticateAndRetryOn401Injected(previousFetch);
      var newProps = {
        fetch: newFetch
      };
      return newProps;
    };
  };
};

exports.wrapAuthenticating = wrapAuthenticating;

var enhance = function enhance() {
  var fetch = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
  return (0, _recompose.compose)((0, _recompose.withProps)(wrapAuthenticating(fetchWithSilentAuthenticateAndRetryOn401((0, _reactOidcRedux.signinSilent)(_reactOidcRedux.getUserManager)))(fetch)));
};

var _default = enhance;
exports["default"] = _default;
//# sourceMappingURL=withFetchSilentAuthenticateAndRetryOn401.js.map